
import com.license4j.FloatingLicenseServer;
import com.license4j.LicenseText;
import com.license4j.exceptions.LicenseSecurityException;
import com.license4j.floatinglicenseserver.data.ClientList;
import com.license4j.floatinglicenseserver.data.FloatingClient;
import com.license4j.floatinglicenseserver.data.FloatingLicense;
import com.license4j.floatinglicenseserver.data.LicenseList;
import java.io.IOException;
import java.net.UnknownHostException;
import java.util.logging.Level;
import java.util.logging.Logger;

public class FloatingLicenseServerQueryExampleMain {

    public static void main(String[] args) {

        /**
         * This the license list, it includes all licenses installed on
         * connected floating license server.
         *
         * Host name, port and socket timeout value should be given.
         *
         */
        LicenseList licenseList;
        try {
            licenseList = FloatingLicenseServer.query("localhost", 16090, 5000);

            /**
             * Loop through license list and print license information.
             */
            for (int i = 0; i < licenseList.size(); i++) {
                FloatingLicense floatingLicense = licenseList.getLicenseByIndex(i);
                System.out.println("---------------------------------------------------");
                System.out.println("License ID: " + floatingLicense.getLicenseID());
                System.out.println("Product Name: " + floatingLicense.getProductName());
                System.out.println("Product Edition: " + floatingLicense.getProductEdition());
                System.out.println("Product Version: " + floatingLicense.getProductVersion());
                System.out.println("Total License Count: " + floatingLicense.getLicenseCount());
                System.out.println("Total License Usage: " + floatingLicense.getLicenseUsageCount());

                /**
                 * Each license has it is own client list, so get the list, loop
                 * through it and print client information here.
                 */
                ClientList clientList = floatingLicense.getClientList();
                for (int j = 0; j < clientList.size(); j++) {
                    System.out.println("\tClients -----------------------------------");
                    FloatingClient floatingClient = clientList.getClientByIndex(j);
                    System.out.println("\tClient ID: " + floatingClient.getClientID());
                    System.out.println("\tHostname: " + floatingClient.getHostname());
                    System.out.println("\tIP Addr: " + floatingClient.getIp());
                    System.out.println("\tUsername: " + floatingClient.getUsername());
                    System.out.println("\tLease Time: " + floatingClient.getIssuetime());
                    System.out.println("\tLast Connect Time: " + floatingClient.getConfirmed());
                }
            }

            /**
             * Save raw usage data to a CSV file if needed.
             */
            //FloatingLicenseServer.getRawReport("localhost", 16090, 5000, 1407138100362L, new File("c:/temp/logs/raw-data.csv"), 30);
        } catch (UnknownHostException ex) {
            Logger.getLogger(FloatingLicenseServerQueryExampleMain.class.getName()).log(Level.SEVERE, "UnknownHostException", ex);
        } catch (IOException ex) {
            Logger.getLogger(FloatingLicenseServerQueryExampleMain.class.getName()).log(Level.SEVERE, "IOException", ex);
        }

    }
}
